<template>
    <div>
        <!-- breadcrumb start -->
        <div class="breadcrumb-section">
            <div class="container">
                <div class="row">
                    <div class="col-sm-6">
                        <div class="page-title">
                            <h2>product</h2>
                        </div>
                    </div>
                    <div class="col-sm-6">
                        <nav aria-label="breadcrumb" class="theme-breadcrumb">
                            <ol class="breadcrumb">
                            </ol>
                        </nav>
                    </div>
                </div>
            </div>
        </div>
        <!-- breadcrumb End -->

        <!-- section start -->
        <section>
            <div class="collection-wrapper">
                <div class="container">
                    <div class="row">
                        <div class="col-lg-6">
                            <div class="product-slick">
                                <div><img :src="product?'/storage/product/'+product.image:''" alt=""
                                          class="img-fluid blur-up lazyload image_zoom_cls-0"></div>
                            </div>
                        </div>
                        <div class="col-lg-6 rtl-text">
                            <div class="product-right">
                                <h2 class="mb-0">{{product.name}}</h2>
                                <h5 class="mb-2">by <a href="javascript:void(0)">{{product.brand.name}}</a></h5>
                                <h4>
<!--                                    <del>${{product.price}}</del>
                                    <span>55% off</span>-->
                                </h4>
                                <h3>Tk. {{product.price}}</h3>
                                <ul class="color-variant">
                                    <li v-for="color in product.colors" class="active" :key="color.id">
                                        <a href="javascript:void(0)">{{color.name}}</a>
                                    </li>
                                </ul>
                                <div class="product-description border-product">
                                    <h6 class="product-title size-text">select size</h6>
                                    <div class="size-box">
                                        <ul>
                                            <li v-for="size in product.sizes" class="active" :key="size.id">
                                                <a href="javascript:void(0)">{{size.name}}</a>
                                            </li>
                                        </ul>
                                    </div>
                                    <h6 class="product-title">quantity</h6>
                                    <div class="qty-box">
                                        <div class="input-group">
                                            <span class="input-group-prepend">
                                                <button type="button" class="btn quantity-left-minus" data-type="minus" data-field="">
                                                    <i class="fa fa-angle-right"></i>
                                                </button>
                                            </span>
                                            <input type="number" name="quantity" class="form-control input-number"
                                                   value="1">
                                            <span class="input-group-prepend">
                                                <button type="button" class="btn quantity-right-plus" data-type="plus" data-field="">
                                                    <i class="fa fa-angle-left"></i>
                                                </button>
                                            </span>
                                        </div>
                                    </div>
                                </div>
                                <div class="product-buttons">
                                    <a href="javascript:void(0)" @click="addCart(product)" data-toggle="modal" data-target="#addtocart"
                                                                class="btn btn-solid">add to cart</a>
                                    <a href="javascript:void(0)" class="btn btn-solid">buy now</a>
                                </div>
                                <div class="border-product">
                                    <h6 class="product-title"></h6>
                                    <p></p>
                                </div>
                                <div class="border-product">
                                    <h6 class="product-title">share it</h6>
                                    <div class="product-icon">
                                        <ul class="product-social">
                                            <li><a href="#"><i class="fa fa-facebook"></i></a></li>
                                            <li><a href="#"><i class="fa fa-google-plus"></i></a></li>
                                            <li><a href="#"><i class="fa fa-twitter"></i></a></li>
                                            <li><a href="#"><i class="fa fa-instagram"></i></a></li>
                                            <li><a href="#"><i class="fa fa-rss"></i></a></li>
                                        </ul>
                                        <form class="d-inline-block">
                                            <button class="wishlist-btn"><i class="fa fa-heart"></i><span
                                                class="title-font">Add To WishList</span></button>
                                        </form>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </section>
        <!-- Section ends -->
        <!-- product-tab starts -->
        <section class="tab-product m-0">
            <div class="container">
                <div class="row">
                    <div class="col-sm-12 col-lg-12">
                        <ul class="nav nav-tabs nav-material" id="top-tab" role="tablist">
                            <li class="nav-item"><a class="nav-link active" id="top-home-tab" data-toggle="tab"
                                                    href="#top-home" role="tab" aria-selected="true">Description</a>
                                <div class="material-border"></div>
                            </li>
                            <li class="nav-item"><a class="nav-link" id="profile-top-tab" data-toggle="tab"
                                                    href="#top-profile" role="tab" aria-selected="false">Condition</a>
                                <div class="material-border"></div>
                            </li>
<!--                            <li class="nav-item"><a class="nav-link" id="contact-top-tab" data-toggle="tab"
                                                    href="#top-contact" role="tab" aria-selected="false">Video</a>
                                <div class="material-border"></div>
                            </li>-->
                            <li class="nav-item"><a class="nav-link" id="review-top-tab" data-toggle="tab"
                                                    href="#top-review" role="tab" aria-selected="false">Write Review</a>
                                <div class="material-border"></div>
                            </li>
                        </ul>
                        <div class="tab-content nav-material" id="top-tabContent">
                            <div class="tab-pane fade show active" id="top-home" role="tabpanel"
                                 aria-labelledby="top-home-tab">
                                <p>{{product.description}}</p>
                            </div>
                            <div class="tab-pane fade" id="top-profile" role="tabpanel"
                                 aria-labelledby="profile-top-tab">
                                <p>{{product.condition}}</p>
                            </div>
<!--                            <div class="tab-pane fade" id="top-contact" role="tabpanel"
                                 aria-labelledby="contact-top-tab">
                                <div class="mt-4 text-center">
                                    <iframe width="560" height="315" src="https://www.youtube.com/embed/BUWzX78Ye_8"
                                            allow="autoplay; encrypted-media" allowfullscreen></iframe>
                                </div>
                            </div>-->
                            <div class="tab-pane fade" id="top-review" role="tabpanel" aria-labelledby="review-top-tab">
                                <form class="theme-form">
                                    <div class="form-row">
                                        <div class="col-md-12">
                                            <div class="media" v-for="rev in reviews">
                                                <label>{{ rev.user.name }}</label>
                                                <div class="media-body ml-3">
                                                    <h6>{{ rev.review}}</h6>
                                                </div>
                                            </div>
                                        </div>
                                        <div v-if="currentUser.isLoggedIn===true" class="col-md-12">
                                            <div class="col-md-12">
                                                <div class="media">
                                                    <label>Rating</label>s
                                                    <div class="media-body ml-3">
                                                        <div class="rating three-star"><i class="fa fa-star"></i> <i
                                                            class="fa fa-star"></i> <i class="fa fa-star"></i> <i
                                                            class="fa fa-star"></i> <i class="fa fa-star"></i></div>
                                                    </div>
                                                </div>
                                            </div>
                                            <form action="javascript:void(0)" method="post">
                                                <div class="col-md-12">
                                                    <textarea class="form-control" v-model="usReview" name="review" placeholder="Write Your review Here"
                                                              rows="6"></textarea>
                                                </div>
                                                <div class="col-md-12">
                                                    <input class="btn btn-solid" @click="reviewSubmit" type="submit" value="Submit your review">
                                                </div>
                                            </form>
                                        </div>
                                        <div class="col-md-12" v-if="currentUser.isLoggedIn===false">
                                            <div class="media">
                                                <center><h4>Please Login first for review <a href="/login">Login</a></h4></center>
                                            </div>
                                        </div>
                                    </div>
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </section>
        <!-- product-tab ends -->

        <!-- product section start -->
        <section class="section-b-space ratio_asos">
            <div class="container">
                <div class="row">
                    <div class="col-12 product-related">
                        <h2>related products</h2>
                    </div>
                </div>
                <div class="row search-product">
                    <div v-for="product in relatedProducts" class="col-xl-2 col-md-4 col-sm-6">
                        <div class="product-box">
                            <div class="img-wrapper">
                                <div class="front" @click="singleProduct(product)">
                                    <a href="javascript:void(0)">
                                        <img :src="'/storage/product/'+product.image"
                                                     class="img-fluid blur-up lazyload bg-img" alt=""></a>
                                </div>
                                <div class="back" @click="singleProduct(product)">
                                    <a href="javascript:void(0)"><img :src="'/storage/product/'+product.image"
                                                     class="img-fluid blur-up lazyload bg-img" alt=""></a>
                                </div>
                                <div class="cart-info cart-wrap">
                                    <button data-toggle="modal" @click="addCart(product)" data-target="#addtocart" title="Add to cart"><i
                                        class="fa fa-shopping-cart"></i></button>
                                    <a href="javascript:void(0)" title="Add to Wishlist">
                                        <i class="fa fa-heart" aria-hidden="true"></i></a>
                                    <a href="javascript:void(0)"
                                       data-toggle="modal" @click="quickView(product)" data-target="#quick-view" title="Quick View"><i
                                        class="fa fa-eye" aria-hidden="true"></i></a>
                                </div>
                            </div>
                            <div class="product-detail" @click="singleProduct(product)">
                                <div class="rating"><i class="fa fa-star"></i> <i class="fa fa-star"></i> <i
                                    class="fa fa-star"></i> <i class="fa fa-star"></i> <i class="fa fa-star"></i></div>
                                <a href="javascript:void(0)">
                                    <h6>{{product.name}} {{product.code}}</h6>
                                </a>
                                <h4>Tk. {{product.price}}</h4>
                                <ul class="color-variant">
                                    <li class="bg-light0"></li>
                                    <li class="bg-light1"></li>
                                    <li class="bg-light2"></li>
                                </ul>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </section>
        <!-- product section end -->
    </div>
</template>

<script>

    import {EventBus} from "./event-bus";

    export default {
        props:{
            product: {
                type: Object,
                required: true,
            },
            currentUser: {
                type: Object,
                required: true
            }
        },
        created(){
            this.getReviews();
        },
        data() {
            return {
                reviews:{},
                usReview:null,
            }
        },
        methods:{
            addCart(product){
                axios.post('/product/add/cart',product).then((response) =>{
                    if (response.data[0] === 0){
                        this.$toaster.error(response.data[1]);
                    }else{
                        this.$toaster.success(response.data[1]);
                    }
                });
            },
            singleProduct(product){
                EventBus.$emit('singleProduct',product);
                this.getReviews();
            },
            async getReviews(){
                await axios.get(`/product/reviews${this.product.id}`).then((response)=>{
                    //console.log(response.data);
                    this.reviews=response.data;
                }).catch((error)=>{
                    this.reviews={};
                });
            },
            reviewSubmit(){
                let data = new FormData();
                data.append('review',this.usReview);
                data.append('product_id',this.product.id);
                data.append('user_id',this.currentUser.user.id);
                axios.post('/product/review/set',data).then((response)=>{
                    let rs = response.data;
                    this.usReview=null;
                    this.getReviews();
                    if (rs===true)
                        this.$toaster.success('Thank you for your review');
                    else
                        this.$toaster.error('Invalid request');
                });
            },
            /*
            * method for product quick view
            * */
            quickView(product){
                EventBus.$emit('quickView',product);
            }
        },
        computed:{
            relatedProducts(){
                return this.$store.getters.products.filter((item)=>{
                    if(item.category_id===this.product.category_id && item.id != this.product.id){
                        return item;
                    }
                });
            }
        }
    }
</script>
